---
###############################################################################
# CI Setup
###############################################################################
stages:
    - .pre

    # Notebooks builder image build
    - Build Notebooks Builder

    # Simple testing stages
    - Test Build Base
    - Test Run
    - Test Build Dependant

    # Development image (development-notebook-ubuntu) stages
    - Development Build Jupyter Base
    - Development Build Base
    - Development Build Dependant
    - Development Validate
    - Development Push Stable
    - Development K8S Pull Image

    # Production stages, triggered by changes to master branch
    - Production Build Jupyter Base
    - Production Build Base
    - Production Build Dependant
    - Production Validate
    - Production Push Stable
    - Production K8S Pull Image

    - .post

before_script:
    - cd $CI_PROJECT_DIR
    - "echo Checking some basic things"
    - date +%Y-%m-%d_%H-%M-%S
    - uname -a
    - hostname
    - id
    - pwd
    - ls
    - "echo Checking various tools that will be needed:"
    - |
        if which buildah; then
            buildah --version
            buildah info
        else
            echo "No buildah installed"
        fi;
    - conda --version
    - which python3
    - python3 --version

variables:
    JOB_NAMESPACE: gitlab-runner
    # Redefine URL here to have the value which will never be overwritten by
    # GitLab (by setting CI_REPOSITORY_URL to another value)
    JUPYTER_DOCKER_STACKS_GIT_URL: $CI_REPOSITORY_URL
    JUPYTER_VALIDATIONS_NOTEBOOKS_GIT_URL: "https://gitlab.maxiv.lu.se/scisw/jupyterhub/jupyter-notebook-validation.git"

    # Image used to perform tasks such as git clone, files copy etc in
    # Kubernetes Jobs
    JUPYTER_HELPER_CONTAINER_IMAGE_NAME: "harbor.maxiv.lu.se/jupyterhub/jupyterhub-builder"
    JUPYTER_HELPER_CONTAINER_IMAGE_TAG: "rocky8.8u1"

    JUPYTER_HELPER_CONTAINER_IMAGE: "$JUPYTER_HELPER_CONTAINER_IMAGE_NAME:$JUPYTER_HELPER_CONTAINER_IMAGE_TAG"

    REG: harbor.maxiv.lu.se
    PROJ: jupyterhub

    VALIDATION_CPU_REQUESTS: "1000m"
    VALIDATION_CPU_LIMITS: "4000m"
    VALIDATION_MEMORY_REQUESTS: "4Gi"
    VALIDATION_MEMORY_LIMITS: "16Gi"

default:
    # Image contains buildah, git, make, Python and other necessary utils.
    # The image starts "bash" by default.
    # Default workdir is /var/www/jupyterhub/jupyter-docker-stacks/.
    image: "$JUPYTER_HELPER_CONTAINER_IMAGE"
    tags:
        - "jupyterkube"

###############################################################################
# Job Templates
###############################################################################
# Build image, push to MAX IV registry
.build_job_template: &build_tag_push_maxiv
    script:
        - "echo Checking environment:"
        - "echo $CI_COMMIT_TIMESTAMP"
        - "echo $CI_COMMIT_SHORT_SHA"
        - "echo $DIR"
        - "echo $OS"
        - "echo $IMAGE_FROM"
        - "echo $REG"
        - "echo $PROJ"
        - "echo $IMG"
        - |
            # If we run a pipeline from GitLab Web UI, the git log will not
            # set a proper tag, so we fallback to "timestamp"
            export TAG=$(git log -n 1 --pretty=format:%cd_%h --date=short)
            if test -z "$TAG"; then
                TAG="build-at-$(date +%Y-%m-%d_%H-%M-%S)"
            fi
        - "echo $TAG"
        - "echo Building image $IMG:$TAG"
        - |
            # Generate Image name for cache.
            __BUILDAH_CACHE_IMAGE="$REG/$PROJ/$IMG-buildah-cache"

            if ( test $BUILDAH_CACHE = "true" ) then
            # Heuristics to use git commit message to disable FROM cache.
            if (echo $CI_COMMIT_MESSAGE | grep -i 'build:nocache' > /dev/null) || ( echo $CI_COMMIT_MESSAGE | grep -i 'build:no-cache' > /dev/null); then
                # Although we do not use cache to build an image, we push
                # layers to cache in order to reuse them in future.
                echo "Building image $REG/$PROJ/$IMG:$TAG without cache";

                __BUILDAH_CACHE_ARGS="--cache-to=$__BUILDAH_CACHE_IMAGE"
            else
                echo "Building image $REG/$PROJ/$IMG:$TAG with cache in $__BUILDAH_CACHE_IMAGE";

                __BUILDAH_CACHE_ARGS="--cache-from=$__BUILDAH_CACHE_IMAGE --cache-to=$__BUILDAH_CACHE_IMAGE"
            fi
                echo "Authenticating to cache registry";
                buildah login -u "$HARBOR_LOGIN" -p "$HARBOR_PASS" "$__BUILDAH_CACHE_IMAGE";
            else
                echo "Building image $REG/$PROJ/$IMG:$TAG without cache";
                __BUILDAH_CACHE_ARGS=""
            fi

        - "buildah bud
          --layers=true
          $__BUILDAH_CACHE_ARGS
          --build-arg NOTEBOOK_VERSION=$IMG:$TAG
          --build-arg IMG_FROM=$IMAGE_FROM
          -t $IMG:$TAG
          -f $DIR/$OS/Dockerfile
          ."

        - "echo Tagging as $REG/$PROJ/$IMG:$TAG"
        - "buildah tag $IMG:$TAG $REG/$PROJ/$IMG:$TAG"
        - "echo Tagging as $REG/$PROJ/$IMG:validate"
        - "buildah tag $IMG:$TAG $REG/$PROJ/$IMG:validate"

        - "echo Logging into buildah"
        - "buildah login -u $HARBOR_LOGIN -p $HARBOR_PASS harbor.maxiv.lu.se"

        - "echo Pushing $REG/$PROJ/$IMG:$TAG to the registry"
        - "buildah push $REG/$PROJ/$IMG:$TAG"
        - "echo Pushing $REG/$PROJ/$IMG:validate to the registry"
        - "buildah push $REG/$PROJ/$IMG:validate"

.push_stable_template: &pull_validate_tag_stable_push_stable
    script:
        - "echo Pulling validation verison of $IMG"
        - "buildah pull $REG/$PROJ/$IMG:validate"

        - "echo Tagging with stable"
        - "buildah tag $REG/$PROJ/$IMG:validate $REG/$PROJ/$IMG:stable"

        - "buildah login -u $HARBOR_LOGIN -p $HARBOR_PASS harbor.maxiv.lu.se"
        - "echo Pushing $REG/$PROJ/$IMG:stable to the registry"
        - "buildah push $REG/$PROJ/$IMG:stable"

        ## Temporary comment out so as not to affect GitLab and
        ## not to fail pipeline during development.
        ## ToDo: uncomment for production
        # - "echo Pushing $NB_IMG to the GitLab registry"
        # - "buildah login -u $GITLAB_USER -p $GITLAB_PASS registry.gitlab.com"
        # - "push to gitlab code goes here"

# Used for remote deployments
.execute_kubernetes_script_template: &execute_kubernetes_script
    before_script:
        - "echo Checking some basic things"
        - date +%Y-%m-%d_%H-%M-%S
        - uname -a
        - hostname
        - id
        - pwd

    script:
        - echo -e "Executing the following commands as Kubernetes Job"
        - echo -e "$K8S_REMOTE_CMD"
        - python helpers/run_kubernetes_job.py

# For pulling docker images onto K8S installation from the registry
.pull_images_k8s_template: &pull_images_k8s
    before_script:
        - export KUBECONFIG=$KUBECONFIG_KICK_DS_IMAGE_PULLER
        - "echo Checking some basic things"
        - date +%Y-%m-%d_%H-%M-%S
        - uname -a
        - hostname
        - id
        - pwd
    script:
        - echo "The kubectl configuration requires the existance of
          the environmental variable KUBECONFIG"
        - kubectl config view
        - echo -n "Start image pulling  "; date +%Y-%m-%d_%H-%M-%S;
        - kubectl rollout restart ds/continuous-image-puller
        - echo "Wait until finished"
        - kubectl rollout status ds/continuous-image-puller
        - echo -n "Done                 "; date +%Y-%m-%d_%H-%M-%S;

# Kubernetes Command Template
# Run the validation tests on the kernels in the image:
#   $REG_PROJ_IMG_TAG
# with kernel:
#   $KERNEL
# and notebooks:
#   $NOTEBOOKS
# The results of the tests are copied to:
#   $OUTPUTDIR
.kubernetes_cmd_validate_copy_template: &kubernetes_cmd_validate_copy
    TAG: validate
    REG_PROJ_IMG_TAG: $REG/$PROJ/$IMG:$TAG
    OUTPUTDIR: /mxn/groups/kits/scisw/jupyterhub/jupyter-notebook-validation-test-results
    K8S_REMOTE_CMD: |
        set -eo pipefail

        date +%Y-%m-%d_%H-%M-%S
        hostname
        id

        echo "Performing validation tests"
        cd /var/www/jupyterhub/jupyter-notebook-validation/
        pwd

        # Double dollar sign is required here because otherwise GitLab
        # tries to resolve variable as its own variable not as
        # exit code or environment variable.
        echo "Validating kernel: $KERNEL"
        echo "Using image: $REG_PROJ_IMG_TAG"
        make execute-test-compare \
          KERNEL=$KERNEL \
          NOTEBOOKS=$NOTEBOOKS || __VAL_EXIT_CODE=$$((__VAL_EXIT_CODE+1))

        echo "Copying validation results for kernel $KERNEL to $OUTPUTDIR"
        make copy-validation-results KERNEL=$KERNEL OUTPUTDIR=$OUTPUTDIR

        exit $$__VAL_EXIT_CODE

# Kubernetes Command Template
# Run the validation tests on the kernels in the image:
#   $REG_PROJ_IMG_TAG
# with kernels:
#   $KERNEL1
#   $KERNEL2
# and notebooks:
#   $NOTEBOOKS1
#   $NOTEBOOKS2
# The results of the tests are copied to:
#   $OUTPUTDIR
.kubernetes_cmd_validate_copy_template_2: &kubernetes_cmd_validate_copy_2
    TAG: validate
    REG_PROJ_IMG_TAG: $REG/$PROJ/$IMG:$TAG
    OUTPUTDIR: /mxn/groups/kits/scisw/jupyterhub/jupyter-notebook-validation-test-results
    K8S_REMOTE_CMD: |
        set -eo pipefail

        date +%Y-%m-%d_%H-%M-%S
        hostname
        id

        echo "Performing validation tests"
        cd /var/www/jupyterhub/jupyter-notebook-validation/
        pwd

        # Double dollar sign is required here because otherwise GitLab
        # tries to resolve variable as its own variable not as
        # exit code or environment variable.
        echo "Validating kernel: $KERNEL1"
        echo "Using image: $REG_PROJ_IMG_TAG"
        make execute-test-compare \
          KERNEL=$KERNEL1 \
          NOTEBOOKS=$NOTEBOOKS1 || __VAL_EXIT_CODE=$$((__VAL_EXIT_CODE+1))

        echo "Copying validation results for kernel $KERNEL1 to $OUTPUTDIR"
        make copy-validation-results KERNEL=$KERNEL1 OUTPUTDIR=$OUTPUTDIR

        echo "Validating kernel: $KERNEL2"
        echo "Using image: $REG_PROJ_IMG_TAG"
        make execute-test-compare \
          KERNEL=$KERNEL2 \
          NOTEBOOKS=$NOTEBOOKS2 || __VAL_EXIT_CODE=$$((__VAL_EXIT_CODE+1))

        echo "Copying validation results for kernel $KERNEL2 to $OUTPUTDIR"
        make copy-validation-results KERNEL=$KERNEL2 OUTPUTDIR=$OUTPUTDIR

        exit $$__VAL_EXIT_CODE

# Kubernetes Command Template
# Run the validation tests on the kernels in the image:
#   $REG_PROJ_IMG_TAG
# with kernels:
#   $KERNEL1
#   $KERNEL2
#   $KERNEL3
# and notebooks:
#   $NOTEBOOKS1
#   $NOTEBOOKS2
#   $NOTEBOOKS3
# The results of the tests are copied to:
#   $OUTPUTDIR
.kubernetes_cmd_validate_copy_template_3: &kubernetes_cmd_validate_copy_3
    TAG: validate
    REG_PROJ_IMG_TAG: $REG/$PROJ/$IMG:$TAG
    OUTPUTDIR: /mxn/groups/kits/scisw/jupyterhub/jupyter-notebook-validation-test-results
    K8S_REMOTE_CMD: |
        set -eo pipefail

        date +%Y-%m-%d_%H-%M-%S
        hostname
        id

        echo "Performing validation tests"
        cd /var/www/jupyterhub/jupyter-notebook-validation/
        pwd

        # Double dollar sign is required here because otherwise GitLab
        # tries to resolve variable as its own variable not as
        # exit code or environment variable.
        echo "Validating kernel: $KERNEL1"
        echo "Using image: $REG_PROJ_IMG_TAG"
        make execute-test-compare \
          KERNEL=$KERNEL1 \
          NOTEBOOKS=$NOTEBOOKS1 || __VAL_EXIT_CODE=$$((__VAL_EXIT_CODE+1))

        echo "Copying validation results for kernel $KERNEL1 to $OUTPUTDIR"
        make copy-validation-results KERNEL=$KERNEL1 OUTPUTDIR=$OUTPUTDIR

        echo "Validating kernel: $KERNEL2"
        echo "Using image: $REG_PROJ_IMG_TAG"
        make execute-test-compare \
          KERNEL=$KERNEL2 \
          NOTEBOOKS=$NOTEBOOKS2 || __VAL_EXIT_CODE=$$((__VAL_EXIT_CODE+1))

        echo "Copying validation results for kernel $KERNEL2 to $OUTPUTDIR"
        make copy-validation-results KERNEL=$KERNEL2 OUTPUTDIR=$OUTPUTDIR

        echo "Validating kernel: $KERNEL3"
        echo "Using image: $REG_PROJ_IMG_TAG"
        make execute-test-compare \
          KERNEL=$KERNEL3 \
          NOTEBOOKS=$NOTEBOOKS3 || __VAL_EXIT_CODE=$$((__VAL_EXIT_CODE+1))

        echo "Copying validation results for kernel $KERNEL3 to $OUTPUTDIR"
        make copy-validation-results KERNEL=$KERNEL3 OUTPUTDIR=$OUTPUTDIR

        exit $$__VAL_EXIT_CODE

# Kubernetes Command Template
# Run the validation tests on the kernels in the image:
#   $REG_PROJ_IMG_TAG
# with kernels:
#   $KERNEL1
#   $KERNEL2
#   $KERNEL3
#   $KERNEL4
#   $KERNEL5
# and notebooks:
#   $NOTEBOOKS1
#   $NOTEBOOKS2
#   $NOTEBOOKS3
#   $NOTEBOOKS4
#   $NOTEBOOKS5
# The results of the tests are copied to:
#   $OUTPUTDIR
.kubernetes_cmd_validate_copy_template_5: &kubernetes_cmd_validate_copy_5
    TAG: validate
    REG_PROJ_IMG_TAG: $REG/$PROJ/$IMG:$TAG
    OUTPUTDIR: /mxn/groups/kits/scisw/jupyterhub/jupyter-notebook-validation-test-results
    K8S_REMOTE_CMD: |
        set -eo pipefail

        date +%Y-%m-%d_%H-%M-%S
        hostname
        id

        echo "Performing validation tests"
        cd /var/www/jupyterhub/jupyter-notebook-validation/
        pwd

        # Double dollar sign is required here because otherwise GitLab
        # tries to resolve variable as its own variable not as
        # exit code or environment variable.
        echo "Validating kernel: $KERNEL1"
        echo "Using image: $REG_PROJ_IMG_TAG"
        make execute-test-compare \
          KERNEL=$KERNEL1 \
          NOTEBOOKS=$NOTEBOOKS1 || __VAL_EXIT_CODE=$$((__VAL_EXIT_CODE+1))

        echo "Copying validation results for kernel $KERNEL1 to $OUTPUTDIR"
        make copy-validation-results KERNEL=$KERNEL1 OUTPUTDIR=$OUTPUTDIR

        echo "Validating kernel: $KERNEL2"
        echo "Using image: $REG_PROJ_IMG_TAG"
        make execute-test-compare \
          KERNEL=$KERNEL2 \
          NOTEBOOKS=$NOTEBOOKS2 || __VAL_EXIT_CODE=$$((__VAL_EXIT_CODE+1))

        echo "Copying validation results for kernel $KERNEL2 to $OUTPUTDIR"
        make copy-validation-results KERNEL=$KERNEL2 OUTPUTDIR=$OUTPUTDIR

        echo "Validating kernel: $KERNEL3"
        echo "Using image: $REG_PROJ_IMG_TAG"
        make execute-test-compare \
          KERNEL=$KERNEL3 \
          NOTEBOOKS=$NOTEBOOKS3 || __VAL_EXIT_CODE=$$((__VAL_EXIT_CODE+1))

        echo "Copying validation results for kernel $KERNEL3 to $OUTPUTDIR"
        make copy-validation-results KERNEL=$KERNEL3 OUTPUTDIR=$OUTPUTDIR

        echo "Validating kernel: $KERNEL4"
        echo "Using image: $REG_PROJ_IMG_TAG"
        make execute-test-compare \
          KERNEL=$KERNEL4 \
          NOTEBOOKS=$NOTEBOOKS4 || __VAL_EXIT_CODE=$$((__VAL_EXIT_CODE+1))

        echo "Copying validation results for kernel $KERNEL4 to $OUTPUTDIR"
        make copy-validation-results KERNEL=$KERNEL4 OUTPUTDIR=$OUTPUTDIR

        echo "Validating kernel: $KERNEL5"
        echo "Using image: $REG_PROJ_IMG_TAG"
        make execute-test-compare \
          KERNEL=$KERNEL5 \
          NOTEBOOKS=$NOTEBOOKS5 || __VAL_EXIT_CODE=$$((__VAL_EXIT_CODE+1))

        echo "Copying validation results for kernel $KERNEL5 to $OUTPUTDIR"
        make copy-validation-results KERNEL=$KERNEL5 OUTPUTDIR=$OUTPUTDIR

        exit $$__VAL_EXIT_CODE

# Copy validation test results to shared directory
.kubernetes_cmd_copy_validation_template:
    &kubernetes_cmd_copy_validation_results
    K8S_REMOTE_CMD: |
        date +%Y-%m-%d_%H-%M-%S &&
        hostname &&
        id &&

        echo "Copying validation results to shared directory" &&
        cd /var/www/jupyterhub/jupyter-notebook-validation/ &&
        pwd &&
        echo -e "copying results for kernel $KERNEL" &&
        make copy-validation-results \
            KERNEL=$KERNEL \
            OUTPUTDIR=/mxn/groups/kits/scisw/jupyterhub/jupyter-notebook-validation-test-results

###############################################################################
# Notebooks builder image
###############################################################################
Build Notebooks Builder:
    stage: Build Notebooks Builder
    # Required here to solve chicken and egg problem:
    # we need at least some image which can build builder.
    image: harbor.maxiv.lu.se/infrastructure/buildah:v1.33.2u1
    variables:
        BUILDAH_CACHE: "true"
    only:
        refs:
            - master
        changes:
            - helpers/builder-image/*
            # - .gitlab-ci.yml
    before_script:
        - cd $CI_PROJECT_DIR
        - "echo Checking some basic things"
        - date +%Y-%m-%d_%H-%M-%S
        - uname -a
    script:
        - |
            # Generate Image name for cache.
            if ( test $BUILDAH_CACHE = "true" ) then
                # Heuristics to use git commit message to disable FROM cache.
                if (echo $CI_COMMIT_MESSAGE | grep -i 'build:nocache' > /dev/null) || ( echo $CI_COMMIT_MESSAGE | grep -i 'build:no-cache' > /dev/null); then
                    # Although we do not use cache to build an image, we push layers to
                    # cache in order to reuse them in future.
                    echo "Building image ${JUPYTER_HELPER_CONTAINER_IMAGE_NAME}:${CI_COMMIT_SHORT_SHA} without cache";

                    __BUILDAH_CACHE_ARGS="--cache-to=${JUPYTER_HELPER_CONTAINER_IMAGE_NAME}-buildah-cache"
                else
                    echo "Building image ${JUPYTER_HELPER_CONTAINER_IMAGE_NAME}:${CI_COMMIT_SHORT_SHA} with cache in ${JUPYTER_HELPER_CONTAINER_IMAGE_NAME}-buildah-cache";

                    __BUILDAH_CACHE_ARGS="--cache-from=${JUPYTER_HELPER_CONTAINER_IMAGE_NAME}-buildah-cache --cache-to=${JUPYTER_HELPER_CONTAINER_IMAGE_NAME}-buildah-cache"
                fi

                echo "Authenticating to cache registry";
                buildah login -u "$HARBOR_LOGIN" -p "$HARBOR_PASS" "${JUPYTER_HELPER_CONTAINER_IMAGE_NAME}-buildah-cache";
            else
                echo "Building image ${JUPYTER_HELPER_CONTAINER_IMAGE_NAME}:${CI_COMMIT_SHORT_SHA} without cache";
                __BUILDAH_CACHE_ARGS=""
            fi

        - 'echo "Building Builder container image $JUPYTER_HELPER_CONTAINER_IMAGE_NAME:$JUPYTER_HELPER_CONTAINER_IMAGE_TAG"'
        - "buildah login -u $HARBOR_LOGIN -p $HARBOR_PASS harbor.maxiv.lu.se"
        - "buildah bud --layers=true $__BUILDAH_CACHE_ARGS -f helpers/builder-image/Dockerfile-rocky -t $JUPYTER_HELPER_CONTAINER_IMAGE_NAME:$CI_COMMIT_SHORT_SHA"
        - "buildah push $JUPYTER_HELPER_CONTAINER_IMAGE_NAME:$CI_COMMIT_SHORT_SHA"
        - "buildah tag  $JUPYTER_HELPER_CONTAINER_IMAGE_NAME:$CI_COMMIT_SHORT_SHA $JUPYTER_HELPER_CONTAINER_IMAGE_NAME:$JUPYTER_HELPER_CONTAINER_IMAGE_TAG"
        - "buildah push $JUPYTER_HELPER_CONTAINER_IMAGE_NAME:$JUPYTER_HELPER_CONTAINER_IMAGE_TAG"
        - "buildah tag  $JUPYTER_HELPER_CONTAINER_IMAGE_NAME:$CI_COMMIT_SHORT_SHA $JUPYTER_HELPER_CONTAINER_IMAGE_NAME:rocky-8-stable"
        - "buildah push $JUPYTER_HELPER_CONTAINER_IMAGE_NAME:rocky-8-stable"
    tags:
        - "kubernetes"

###############################################################################
# Tests - build, clean, deploy
###############################################################################
.temp_trigger_template:
    only: &temp_trigger
        changes:
            - .gitlab-ci.yml

Test Build Base:
    stage: Test Build Base
    <<: *build_tag_push_maxiv
    only:
        refs:
            - some-branch
    variables:
        NB_IMG: test-notebook-ubuntu

Test Run:
    stage: Test Run
    only:
        refs:
            - some-branch
    variables:
        NB_IMG: test-notebook-ubuntu
        K8S_REMOTE_CMD: "cowsay 'Hello Kubernetes'"
    script:
        - "echo Running a test"
        - "python helpers/run_kubernetes_job.py"

Test Build Test Build Dependant:
    stage: Test Build Dependant
    <<: *build_tag_push_maxiv
    only:
        refs:
            - some-branch
    variables:
        NB_IMG: test-notebook-dependant-ubuntu
###############################################################################

###############################################################################
# Development Image - build, clean, deploy
###############################################################################
Development Build Jupyter Base Cuda 12.2:
    <<: *build_tag_push_maxiv
    stage: Development Build Jupyter Base
    variables:
        IMG: dev-jupyter-base-ubuntu-bionic-cuda-12-2
        DIR: jupyter-base
        OS: ubuntu-bionic-cuda-12-2
        IMAGE_FROM: "false"
    only:
        refs:
            - some-branch
            - update-jupyterlab-jupyterhub
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            # - .gitlab-ci.yml

Development Build Base New Cuda 12.2:
    <<: *build_tag_push_maxiv
    stage: Development Build Base
    variables:
        IMG: dev-base-new-notebook-ubuntu-bionic-cuda-12-2
        DIR: base-new-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM:
            $REG/$PROJ/dev-jupyter-base-ubuntu-bionic-cuda-12-2:validate
    only:
        refs:
            - some-branch
            - update-jupyterlab-jupyterhub
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            # - .gitlab-ci.yml

.development_build_trigger_template:
    only: &development_build_trigger
        refs:
            - some-branch
            - update-jupyterlab-jupyterhub
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            - bloch-notebook/ubuntu-bionic-22-4/*
            - conda-notebook/ubuntu-bionic-22-4/*
            - danmax-notebook/ubuntu-bionic-22-4/*
            - hdf5-notebook/ubuntu-bionic-22-4/*
            - matlab-notebook/ubuntu-bionic-22-4/*
            - formax-notebook/ubuntu-bionic-22-4/*
            - maxpeem-notebook/ubuntu-bionic-22-4/*
            - tomography-notebook/ubuntu-bionic-22-4/*
            - .gitlab-ci.yml

Development Build Dependant:
    stage: Development Build Dependant
    only: *development_build_trigger
    variables:
        IMG: development-notebook-ubuntu-bionic
        DIR: hdf5-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM:
            $REG/$PROJ/dev-base-new-notebook-ubuntu-bionic-cuda-12-2:validate
    <<: *build_tag_push_maxiv

Development Validate Dependent:
    stage: Development Validate
    only: *development_build_trigger
    variables:
        IMG: development-notebook-ubuntu-bionic
        KERNEL: maxiv-jhub-docker-kernel-hdf5
        NOTEBOOKS: notebooks/maxiv/hdf5/00*.ipynb
        <<: *kubernetes_cmd_validate_copy
    <<: *execute_kubernetes_script
    allow_failure: true

Development Push Stable Dependent:
    stage: Development Push Stable
    only: *development_build_trigger
    variables:
        IMG: development-notebook-ubuntu-bionic
    <<: *pull_validate_tag_stable_push_stable

Development K8S Pull Image:
    stage: Development K8S Pull Image
    only: *development_build_trigger
    <<: *pull_images_k8s
    allow_failure: true
###############################################################################

###############################################################################
# Production Base Images
###############################################################################
Jupyter Base Cuda 12.2:
    <<: *build_tag_push_maxiv
    stage: Production Build Jupyter Base
    variables:
        IMG: jupyter-base-ubuntu-bionic-cuda-12-2
        DIR: jupyter-base
        OS: ubuntu-bionic-cuda-12-2
        IMAGE_FROM: "false"
    only:
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*

Base New Cuda 12.2:
    <<: *build_tag_push_maxiv
    stage: Production Build Base
    variables:
        IMG: base-new-notebook-ubuntu-bionic-cuda-12-2
        DIR: base-new-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM: $REG/$PROJ/jupyter-base-ubuntu-bionic-cuda-12-2:validate
    only:
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*

###############################################################################
# Tomography Image
###############################################################################
.tomography_build_validate_push_template:
    only: &tomography_build_validate_push_trigger
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            - tomography-notebook/ubuntu-bionic-22-4/*

Build Tomography:
    stage: Production Build Dependant
    only: *tomography_build_validate_push_trigger
    variables:
        IMG: tomography-notebook-ubuntu-bionic
        DIR: tomography-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM:
            $REG/$PROJ/base-new-notebook-ubuntu-bionic-cuda-12-2:validate
    <<: *build_tag_push_maxiv

Validate Tomography Imquant:
    stage: Production Validate
    needs: [Build Tomography]
    only: *tomography_build_validate_push_trigger
    variables:
        # Requires more memory than default.
        VALIDATION_MEMORY_LIMITS: "40Gi"
        IMG: tomography-notebook-ubuntu-bionic
        KERNEL: maxiv-jhub-docker-kernel-tomography-imquant
        NOTEBOOKS: notebooks/maxiv/tomography-imquant/*
        <<: *kubernetes_cmd_validate_copy
    <<: *execute_kubernetes_script
    allow_failure: true

Validate Tomography Rectv Spam Xphase:
    stage: Production Validate
    needs: [Validate Tomography Imquant]
    only: *tomography_build_validate_push_trigger
    variables:
        IMG: tomography-notebook-ubuntu-bionic
        KERNEL1: maxiv-jhub-docker-kernel-tomography-rectv
        NOTEBOOKS1: notebooks/maxiv/tomography-rectv/*
        KERNEL2: maxiv-jhub-docker-kernel-tomography-spam
        NOTEBOOKS2: notebooks/maxiv/tomography-spam/*
        KERNEL3: maxiv-jhub-docker-kernel-tomography-xphase
        NOTEBOOKS3: notebooks/maxiv/tomography-xphase/*
        <<: *kubernetes_cmd_validate_copy_3
    <<: *execute_kubernetes_script
    allow_failure: true

Validate Tomography Tomorec:
    stage: Production Validate
    needs: [Validate Tomography Rectv Spam Xphase]
    only: *tomography_build_validate_push_trigger
    variables:
        # Requires more memory than default.
        VALIDATION_MEMORY_LIMITS: "25Gi"
        IMG: tomography-notebook-ubuntu-bionic
        KERNEL: maxiv-jhub-docker-kernel-tomography-tomorec
        NOTEBOOKS: notebooks/maxiv/tomography-tomorec/*
        <<: *kubernetes_cmd_validate_copy
    <<: *execute_kubernetes_script
    allow_failure: true

Push Tomography:
    stage: Production Push Stable
    needs: [Validate Tomography Tomorec]
    only: *tomography_build_validate_push_trigger
    variables:
        IMG: tomography-notebook-ubuntu-bionic
    <<: *pull_validate_tag_stable_push_stable

###############################################################################
# Matlab Image
###############################################################################
.matlab_build_validate_push_template:
    only: &matlab_build_validate_push_trigger
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            - matlab-notebook/ubuntu-bionic-22-4/*

Build Matlab:
    stage: Production Build Dependant
    only: *matlab_build_validate_push_trigger
    variables:
        IMG: matlab-notebook-ubuntu-bionic
        DIR: matlab-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM:
            $REG/$PROJ/base-new-notebook-ubuntu-bionic-cuda-12-2:validate
    <<: *build_tag_push_maxiv

Validate Matlab:
    stage: Production Validate
    needs: [Build Matlab]
    only: *matlab_build_validate_push_trigger
    variables:
        IMG: matlab-notebook-ubuntu-bionic
        KERNEL: maxiv-jhub-docker-kernel-matlab
        NOTEBOOKS: notebooks/maxiv/matlab/00*
        <<: *kubernetes_cmd_validate_copy
    <<: *execute_kubernetes_script
    allow_failure: true

Push Matlab:
    stage: Production Push Stable
    needs: [Validate Matlab]
    only: *matlab_build_validate_push_trigger
    variables:
        IMG: matlab-notebook-ubuntu-bionic
    <<: *pull_validate_tag_stable_push_stable

###############################################################################
# Bloch - Validate & Deploy
###############################################################################
.bloch_build_validate_push_template:
    only: &bloch_build_validate_push_trigger
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            - bloch-notebook/ubuntu-bionic-22-4/*

Build Bloch:
    stage: Production Build Dependant
    only: *bloch_build_validate_push_trigger
    variables:
        IMG: bloch-notebook-ubuntu-bionic
        DIR: bloch-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM:
            $REG/$PROJ/base-new-notebook-ubuntu-bionic-cuda-12-2:validate
    <<: *build_tag_push_maxiv

Validate Bloch:
    stage: Production Validate
    needs: [Build Bloch]
    only: *bloch_build_validate_push_trigger
    variables:
        IMG: bloch-notebook-ubuntu-bionic
        KERNEL: maxiv-jhub-docker-kernel-bloch
        NOTEBOOKS: notebooks/maxiv/bloch/00*
        <<: *kubernetes_cmd_validate_copy
    <<: *execute_kubernetes_script
    allow_failure: true

Push Bloch:
    stage: Production Push Stable
    needs: [Validate Bloch]
    only: *bloch_build_validate_push_trigger
    variables:
        IMG: bloch-notebook-ubuntu-bionic
    <<: *pull_validate_tag_stable_push_stable

###############################################################################
# Conda Image
###############################################################################
.conda_build_validate_push_template:
    only: &conda_build_validate_push_trigger
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            - conda-notebook/ubuntu-bionic-22-4/*

Build Conda:
    stage: Production Build Dependant
    only: *conda_build_validate_push_trigger
    variables:
        IMG: conda-notebook-ubuntu-bionic
        DIR: conda-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM:
            $REG/$PROJ/base-new-notebook-ubuntu-bionic-cuda-12-2:validate
    <<: *build_tag_push_maxiv

Validate Conda:
    stage: Production Validate
    needs: [Build Conda]
    only: *conda_build_validate_push_trigger
    variables:
        IMG: conda-notebook-ubuntu-bionic
        KERNEL: python3
        NOTEBOOKS: notebooks/maxiv/conda/0[0-1]*
        <<: *kubernetes_cmd_validate_copy
    <<: *execute_kubernetes_script
    allow_failure: true

Push Conda:
    stage: Production Push Stable
    needs: [Validate Conda]
    only: *conda_build_validate_push_trigger
    variables:
        IMG: conda-notebook-ubuntu-bionic
    <<: *pull_validate_tag_stable_push_stable

###############################################################################
# DanMax Image
###############################################################################
.danmax_build_validate_push_template:
    only: &danmax_build_validate_push_trigger
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            - danmax-notebook/ubuntu-bionic-22-4/*

Build DanMax:
    stage: Production Build Dependant
    only: *danmax_build_validate_push_trigger
    variables:
        IMG: danmax-notebook-ubuntu-bionic
        DIR: danmax-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM:
            $REG/$PROJ/base-new-notebook-ubuntu-bionic-cuda-12-2:validate
    <<: *build_tag_push_maxiv

Validate DanMax:
    stage: Production Validate
    needs: [Build DanMax]
    only: *danmax_build_validate_push_trigger
    variables:
        IMG: danmax-notebook-ubuntu-bionic
        KERNEL: maxiv-jhub-docker-kernel-danmax
        NOTEBOOKS: notebooks/maxiv/danmax/00*
        <<: *kubernetes_cmd_validate_copy
    <<: *execute_kubernetes_script
    allow_failure: true

Push DanMax:
    stage: Production Push Stable
    needs: [Validate DanMax]
    only: *danmax_build_validate_push_trigger
    variables:
        IMG: danmax-notebook-ubuntu-bionic
    <<: *pull_validate_tag_stable_push_stable


###############################################################################
# ForMax Image
###############################################################################
.formax_build_validate_push_template:
    only: &formax_build_validate_push_trigger
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            - formax-notebook/ubuntu-bionic-22-4/*

Build ForMax:
    stage: Production Build Dependant
    only: *formax_build_validate_push_trigger
    variables:
        IMG: formax-notebook-ubuntu-bionic
        DIR: formax-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM:
            $REG/$PROJ/base-new-notebook-ubuntu-bionic-cuda-12-2:validate
    <<: *build_tag_push_maxiv

Validate ForMax:
    stage: Production Validate
    needs: [Build ForMax]
    only: *formax_build_validate_push_trigger
    variables:
        IMG: formax-notebook-ubuntu-bionic
        KERNEL: maxiv-jhub-docker-kernel-formax-tomography
        NOTEBOOKS: notebooks/maxiv/hdf5/00*
        <<: *kubernetes_cmd_validate_copy
    <<: *execute_kubernetes_script
    allow_failure: true

Push ForMax:
    stage: Production Push Stable
    needs: [Validate ForMax]
    only: *formax_build_validate_push_trigger
    variables:
        IMG: formax-notebook-ubuntu-bionic
    <<: *pull_validate_tag_stable_push_stable

###############################################################################
# MAXPEEM Image
###############################################################################
.maxpeem_build_validate_push_template:
    only: &maxpeem_build_validate_push_trigger
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            - maxpeem-notebook/ubuntu-bionic-22-4/*

Build MAXPEEM:
    stage: Production Build Dependant
    only: *maxpeem_build_validate_push_trigger
    variables:
        IMG: maxpeem-notebook-ubuntu-bionic
        DIR: maxpeem-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM:
            $REG/$PROJ/base-new-notebook-ubuntu-bionic-cuda-12-2:validate
    <<: *build_tag_push_maxiv

Validate MAXPEEM:
    stage: Production Validate
    needs: [Build MAXPEEM]
    only: *maxpeem_build_validate_push_trigger
    variables:
        IMG: maxpeem-notebook-ubuntu-bionic
        KERNEL: maxiv-jhub-docker-kernel-maxpeem
        NOTEBOOKS: notebooks/maxiv/hdf5/00*
        <<: *kubernetes_cmd_validate_copy
    <<: *execute_kubernetes_script
    allow_failure: true

Push MAXPEEM:
    stage: Production Push Stable
    needs: [Validate MAXPEEM]
    only: *maxpeem_build_validate_push_trigger
    variables:
        IMG: maxpeem-notebook-ubuntu-bionic
    <<: *pull_validate_tag_stable_push_stable

###############################################################################
# HDF5 Image
###############################################################################
.hdf5_build_validate_push_template:
    only: &hdf5_build_validate_push_trigger
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            - hdf5-notebook/ubuntu-bionic-22-4/*

Build HDF5:
    stage: Production Build Dependant
    only: *hdf5_build_validate_push_trigger
    variables:
        IMG: hdf5-notebook-ubuntu-bionic
        DIR: hdf5-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM:
            $REG/$PROJ/base-new-notebook-ubuntu-bionic-cuda-12-2:validate
    <<: *build_tag_push_maxiv

Validate HDF5:
    stage: Production Validate
    needs: [Build HDF5]
    only: *hdf5_build_validate_push_trigger
    variables:
        IMG: hdf5-notebook-ubuntu-bionic
        KERNEL: maxiv-jhub-docker-kernel-hdf5
        NOTEBOOKS: notebooks/maxiv/hdf5/00*
        <<: *kubernetes_cmd_validate_copy
    <<: *execute_kubernetes_script
    allow_failure: true

Push HDF5:
    stage: Production Push Stable
    needs: [Validate HDF5]
    only: *hdf5_build_validate_push_trigger
    variables:
        IMG: hdf5-notebook-ubuntu-bionic
    <<: *pull_validate_tag_stable_push_stable

###############################################################################
# Balder Image
###############################################################################
.balder_build_validate_push_template:
    only: &balder_build_validate_push_trigger
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            - balder-notebook/ubuntu-bionic-22-4/*

Build Balder:
    stage: Production Build Dependant
    only: *balder_build_validate_push_trigger
    variables:
        IMG: balder-notebook-ubuntu-bionic
        DIR: balder-notebook
        OS: ubuntu-bionic-22-4
        IMAGE_FROM:
            $REG/$PROJ/base-new-notebook-ubuntu-bionic-cuda-12-2:validate
    <<: *build_tag_push_maxiv

Validate Balder:
    stage: Production Validate
    needs: [Build Balder]
    only: *balder_build_validate_push_trigger
    variables:
        IMG: balder-notebook-ubuntu-bionic
        KERNEL: maxiv-jhub-docker-kernel-balder
        NOTEBOOKS: notebooks/maxiv/balder/00*
        <<: *kubernetes_cmd_validate_copy
    <<: *execute_kubernetes_script
    allow_failure: true

Push Balder:
    stage: Production Push Stable
    needs: [Validate Balder]
    only: *balder_build_validate_push_trigger
    variables:
        IMG: balder-notebook-ubuntu-bionic
    <<: *pull_validate_tag_stable_push_stable

###############################################################################
# Production K8S Deployment
###############################################################################
# Trigger pulling of new images from the registry onto the K8S cluster
Production K8S Pull Image:
    stage: Production K8S Pull Image
    only:
        refs:
            - master
        changes:
            - jupyter-base/*
            - jupyter-base/ubuntu-bionic-cuda-12-2/*
            - base-new-notebook/*
            - base-new-notebook/ubuntu-bionic-22-4/*
            - hdf5-notebook/ubuntu-bionic-22-4/*
            - bloch-notebook/ubuntu-bionic-22-4/*
            - conda-notebook/ubuntu-bionic-22-4/*
            - danmax-notebook/ubuntu-bionic-22-4/*
            - maxpeem-notebook/ubuntu-bionic-22-4/*
            - formax-notebook/ubuntu-bionic-22-4/*
            - matlab-notebook/ubuntu-bionic-22-4/*
            - tomography-notebook/ubuntu-bionic-22-4/*
            # - .gitlab-ci.yml
    environment:
        name: Production K8S Pull Image
    <<: *pull_images_k8s
###############################################################################
